diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/PhylogeneticTree.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/PhylogeneticTree.java
index fc1e1889a7..5f4fdefcb4 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/PhylogeneticTree.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/PhylogeneticTree.java
@@ -10,15 +10,12 @@
 package eu.etaxonomy.cdm.model.molecular;
 
 
-import eu.etaxonomy.cdm.model.media.ReferencedMediaBase;
+import java.util.HashSet;
+import java.util.Set;
 
-import org.apache.log4j.Logger;
-import org.hibernate.envers.Audited;
-import org.hibernate.search.annotations.Indexed;
-
-import java.util.*;
-
-import javax.persistence.*;
+import javax.persistence.Entity;
+import javax.persistence.FetchType;
+import javax.persistence.ManyToMany;
 import javax.validation.constraints.NotNull;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
@@ -29,10 +26,22 @@ import javax.xml.bind.annotation.XmlRootElement;
 import javax.xml.bind.annotation.XmlSchemaType;
 import javax.xml.bind.annotation.XmlType;
 
+import org.apache.log4j.Logger;
+import org.hibernate.envers.Audited;
+import org.hibernate.search.annotations.Indexed;
+
+import eu.etaxonomy.cdm.model.media.Media;
+
 /**
+ * "A phylogenetic tree or evolutionary tree is a branching diagram or "tree" showing the 
+ * inferred evolutionary relationships among various biological species or other entities 
+ * based upon similarities and differences in their physical and/or genetic characteristics. 
+ * The taxa joined together in the tree are implied to have descended from a common ancestor."
+ * (Wikipedia).
+ * <BR> In the CDM we currently store phylogenetic trees only as media. This may change in future.
+ * 
  * @author m.doering
- * @version 1.0
- * @created 08-Nov-2007 13:06:43
+ * @created 08-Nov-2007
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "PhylogeneticTree", propOrder = {
@@ -42,18 +51,40 @@ import javax.xml.bind.annotation.XmlType;
 @Entity
 @Indexed(index = "eu.etaxonomy.cdm.model.media.Media")
 @Audited
-public class PhylogeneticTree extends ReferencedMediaBase implements Cloneable{
+public class PhylogeneticTree extends Media implements Cloneable{
 	private static final long serialVersionUID = -7020182117362324067L;
 	private static final  Logger logger = Logger.getLogger(PhylogeneticTree.class);
 	
+	
 	@XmlElementWrapper(name = "UsedSequences")
 	@XmlElement(name = "UsedSequence")
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
-    @OneToMany(fetch = FetchType.LAZY)// FIXME surely should be ManyToMany - you can use a sequence to construct several different phylogenetic trees
+    @ManyToMany(fetch = FetchType.LAZY)
     @NotNull
 	private Set<Sequence> usedSequences = new HashSet<Sequence>();
 	
+//********************** Factory Method **********************************/
+	
+    /**
+     * Factory method
+     * @return
+     */
+    public static PhylogeneticTree NewInstance(){
+        return new PhylogeneticTree();
+    }
+
+    
+//***************** Constructor ****************************/
+    
+    private PhylogeneticTree(){
+    	super();
+    }
+	
+
+    
+// ********************** GETTER / SETTER **************************/
+	
 	public Set<Sequence> getUsedSequences() {
 		if(usedSequences == null) {
 			this.usedSequences = new HashSet<Sequence>();
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Primer.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Primer.java
new file mode 100644
index 0000000000..094ccfb4b8
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Primer.java
@@ -0,0 +1,162 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.model.molecular;
+
+import javax.persistence.Entity;
+import javax.persistence.FetchType;
+import javax.persistence.ManyToOne;
+import javax.validation.constraints.Size;
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlElement;
+import javax.xml.bind.annotation.XmlIDREF;
+import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.XmlSchemaType;
+import javax.xml.bind.annotation.XmlType;
+
+import org.apache.log4j.Logger;
+import org.hibernate.annotations.Cascade;
+import org.hibernate.annotations.CascadeType;
+import org.hibernate.envers.Audited;
+
+import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
+import eu.etaxonomy.cdm.model.reference.Reference;
+
+/**
+ * A primer is a (short) DNA Sequence used for replication and extraction
+ * of DNA parts during e.g. {@link Amplification amplification} or 
+ * {@link SingleRead sequence reading}.
+ * 
+ * @author a.mueller
+ * @created 2013-07-08
+ *
+ */
+@XmlAccessorType(XmlAccessType.FIELD)
+@XmlType(name = "Primer", propOrder = {
+	"label",
+	"sequence",
+	"publishedIn"
+})
+@XmlRootElement(name = "Primer")
+@Entity
+@Audited
+//TODO which base class  (..., identifiable, definedTerm, ...)
+public class Primer extends AnnotatableEntity {
+	private static final long serialVersionUID = 6179007910988646989L;
+	private static final Logger logger = Logger.getLogger(Primer.class);
+	
+	/** @see #getLabel() */
+	@XmlElement(name = "Label")
+	@Size(max=255)
+	private String label;
+	
+	/** @see #getSequence() */
+	@XmlElement(name = "Sequence")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+    @ManyToOne(fetch=FetchType.LAZY)
+    @Cascade({CascadeType.SAVE_UPDATE})
+	private Sequence sequence;
+    
+	/** @see #getPublishedIn() */
+	@XmlElement(name = "PublishedIn")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+    @ManyToOne(fetch=FetchType.LAZY)
+    @Cascade({CascadeType.SAVE_UPDATE})
+	private Reference<?> publishedIn;
+
+	// ******************** FACTORY METHOD ******************/	
+	
+	public static Primer NewInstance(String label){
+		Primer result = new Primer();
+		result.setLabel(label);
+		return result;
+	}
+	
+	// ********************* CONSTRUCTOR ********************/
+		
+	private Primer(){};
+	
+// ********************* GETTER / SETTER ********************/
+	
+
+	/**
+	 * The name of this primer, usually given by the producers.
+	 * @return the label of this primer.
+	 */
+	public String getLabel() {
+		return label;
+	}
+
+	/**
+	 * @see #getLabel()
+	 */
+	public void setLabel(String label) {
+		this.label = label;
+	}
+
+	/**
+	 * The DNA {@link Sequence} of this primer. A primer is usually a 
+	 * small piece of DNA and therefore can be expressed as a sequence.
+	 */
+	public Sequence getSequence() {
+		return sequence;
+	}
+
+	/**
+	 * @see Primer#getSequence()
+	 */
+	public void setSequence(Sequence sequence) {
+		this.sequence = sequence;
+	}
+	
+	/**
+	 * The reference in which this primer was published and described 
+	 * for the first time. It is not a reference or citation for the 
+	 * sequence of this primer.<BR>
+	 * Links to this reference are stored with the reference itself.
+	 * @return the describing publication of this primer
+	 */
+	public Reference getPublishedIn() {
+		return publishedIn;
+	}
+
+	/**
+	 * @see #getPublishedIn()
+	 */
+	public void setPublishedIn(Reference publishedIn) {
+		this.publishedIn = publishedIn;
+	}
+
+	// ********************* CLONE ********************/
+	/** 
+	 * Clones <i>this</i> sequence. This is a shortcut that enables to create
+	 * a new instance that differs only slightly from <i>this</i> sequencing by
+	 * modifying only some of the attributes.<BR><BR>
+	 * 
+	 *  
+	 * @see eu.etaxonomy.cdm.model.media.IdentifiableEntity#clone()
+	 * @see java.lang.Object#clone()
+	 */
+	@Override
+	public Object clone()  {
+		try{
+		Sequence result = (Sequence)super.clone();
+
+//		don't change label, sequence
+		
+		return result;
+		}catch (CloneNotSupportedException e) {
+			logger.warn("Object does not implement cloneable");
+			e.printStackTrace();
+			return null;
+		}
+	}
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Sequence.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Sequence.java
index 1f912662fd..71827e0bab 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Sequence.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/molecular/Sequence.java
@@ -6,19 +6,19 @@
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
-
 package eu.etaxonomy.cdm.model.molecular;
 
 
+import java.net.URI;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.persistence.Basic;
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
+import javax.persistence.ManyToMany;
 import javax.persistence.ManyToOne;
-import javax.persistence.OneToMany;
 import javax.persistence.Transient;
+import javax.validation.constraints.Size;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlAttribute;
@@ -28,254 +28,481 @@ import javax.xml.bind.annotation.XmlIDREF;
 import javax.xml.bind.annotation.XmlRootElement;
 import javax.xml.bind.annotation.XmlSchemaType;
 import javax.xml.bind.annotation.XmlType;
-import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
 
 import org.apache.log4j.Logger;
+import org.codehaus.plexus.util.StringUtils;
 import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
-import org.hibernate.annotations.Index;
-import org.hibernate.annotations.Table;
-import org.hibernate.annotations.Type;
 import org.hibernate.envers.Audited;
-import org.joda.time.DateTime;
+import org.hibernate.search.annotations.IndexedEmbedded;
 import org.springframework.beans.factory.annotation.Configurable;
 
-import eu.etaxonomy.cdm.jaxb.DateTimeAdapter;
-import eu.etaxonomy.cdm.model.common.IReferencedEntity;
-import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
-import eu.etaxonomy.cdm.model.media.IMediaDocumented;
+import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.reference.Reference;
-import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
-import eu.etaxonomy.cdm.strategy.cache.common.IdentifiableEntityDefaultCacheStrategy;
 
 /**
+ * Alignment of multiple {@link SingleRead single sequences} to a consensus sequence.
+ * This sequence is a part of (or the complete) DNA sequences of the related {@link DnaSample DNA Sample},
+ * while 
+ * 
+ * <BR>This class holds information about both the combining process of 
+ * {@link SingleRead single sequences} to one consensus sequence
+ * ({@link #getSingleReads() singleReads} , {@link #getContigFile() contigFile} ) 
+ * as well as sequence related information.
+ * The later includes the {@link #getConsensusSequence() sequence string} itself, 
+ * important genetic information about the DNA that has been sequenced 
+ * ({@link #getDnaMarker() marker} , {@link #getHaplotype()} haplotype) as well as 
+ * registration information ({@link #getGeneticAccessionNumber() genetic accession number} ),
+ * citations, and barcoding information ({@link #getBoldProcessId() BOLD-id}, 
+ * {@link #getBarcodeSequencePart() barcode sequence}, ...).
+ * 
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:51
+ * @author a.mueller
+ * @updated 11-Jul-2013
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "Sequence", propOrder = {
-    "sequence",
-    "length",
-    "dateSequenced",
-    "barcode",
-    "citationMicroReference",
-    "publishedIn",
-    "locus",
-    "citations",
-    "genBankAccession",
-    "chromatograms"
+    "dnaSample",
+	"consensusSequence",
+	"isBarcode",
+    "barcodeSequencePart",
+    "dnaMarker",
+    "geneticAccessionNumber",
+    "boldProcessId",
+    "haplotype",
+    "contigFile",
+    "singleReads",
+    "citations"
 })
-@XmlRootElement(name = "Sequence")
+@XmlRootElement(name = "Sequencing")
 @Entity
 @Audited
 @Configurable
-@Table(appliesTo="Sequence", indexes = { @Index(name = "sequenceTitleCacheIndex", columnNames = { "titleCache" }) })
-public class Sequence extends IdentifiableEntity<IIdentifiableEntityCacheStrategy<Sequence>> implements IReferencedEntity, IMediaDocumented{
+//@Table(appliesTo="Sequence", indexes = { @Index(name = "sequenceTitleCacheIndex", columnNames = { "titleCache" }) })
+public class Sequence extends AnnotatableEntity implements Cloneable{
 	private static final long serialVersionUID = 8298983152731241775L;
 	private static final Logger logger = Logger.getLogger(Sequence.class);
 	
-	//the sequence as a string of base pairs. 5'->3'
-	@XmlElement(name = "Sequence")
-	private String sequence;
+	//TODO move to cdmlib-ext?
+	private static final String GENBANK_BASE_URI = "http://www.ncbi.nlm.nih.gov/nuccore/%s";
+	private static final String EMBL_BASE_URI = "http://www.ebi.ac.uk/ena/data/view/%s";
+	private static final String DDBJ_BASE_URI = "http://getentry.ddbj.nig.ac.jp/getentry/na/%s/?filetype=html";
+	private static final String BOLD_BASE_URI = "http://www.boldsystems.org/index.php/Public_RecordView?processid=%s";
 	
-	//should be calculated in case sequence is set
-	@XmlElement(name = "Length")
-	private Integer length;
+    @XmlElement( name = "DnaSample")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+    @ManyToOne(fetch = FetchType.LAZY)
+    @IndexedEmbedded
+    private DnaSample dnaSample;
+    
 	
-	//should be calculated in case sequence is set
-	@XmlElement (name = "DateSequenced", type= String.class)
-	@XmlJavaTypeAdapter(DateTimeAdapter.class)
-	@Type(type="dateTimeUserType")
-	@Basic(fetch = FetchType.LAZY)
-	private DateTime dateSequenced;
+	/** @see #getContigFile() */
+	@XmlElement(name = "ContigFile")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+    @ManyToOne(fetch = FetchType.LAZY)
+	private Media contigFile;
+    
+	/** @see #getConsensusSequence() */
+	@XmlElement(name = "ConsensusSequence")
+    private SequenceString consensusSequence = SequenceString.NewInstance();
 	
-	//should be calculated in case sequence is set
 	@XmlAttribute(name = "isBarcode")
-	private boolean barcode;
+	private Boolean isBarcode = null;
 	
-	//the sequence as a string of base pairs. 5'->3'
-	@XmlElement(name = "CitationMicroReference")
-	private String citationMicroReference;
+	/** @see #getBarcodeSequence()*/
+	@XmlElement(name = "BarcodeSequencePart")
+    private SequenceString barcodeSequencePart = SequenceString.NewInstance();
+
+	/** @see #getGeneticAccessionNumber()*/
+	@XmlElement(name = "GeneticAccessionNumber")
+	@Size(max=20)
+	private String geneticAccessionNumber;
+    
+	/** @see #getBoldProcessId() */
+	@XmlElement(name = "BoldProcessId")
+	@Size(max=20)
+	private String boldProcessId;
 	
-	@XmlElement(name = "PublishedIn")
+    @XmlElementWrapper(name = "SingleReads")
+    @XmlElement(name = "SingleRead")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+    @ManyToMany(fetch = FetchType.LAZY)
+    @Cascade({CascadeType.SAVE_UPDATE})
+	private Set<SingleRead> singleReads = new HashSet<SingleRead>();
+    
+	/** @see #getDnaMarker() */
+	@XmlElement(name = "DnaMarker")
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
     @ManyToOne(fetch = FetchType.LAZY)
-    @Cascade(CascadeType.SAVE_UPDATE)
-	private Reference<?> publishedIn;
+	//no cascade as it is a defined term
+	private DefinedTerm dnaMarker;
+
+	
+	/** @see #getHaplotype() */
+	@XmlElement(name = "Haplotype")
+	@Size(max=100)
+	private String haplotype;
 	
+	/** @see #getCitations() */
 	@XmlElementWrapper(name = "Citations")
-	@XmlElement(name = "Citation")
+    @XmlElement(name = "Citation")
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
-    @OneToMany(fetch = FetchType.LAZY)
+    @ManyToMany(fetch = FetchType.LAZY)
+    @Cascade({CascadeType.SAVE_UPDATE})
 	private Set<Reference> citations = new HashSet<Reference>();
 	
-	@XmlElementWrapper(name = "GenBankAccessions")
-	@XmlElement(name = "GenBankAccession")
-    @OneToMany(fetch = FetchType.LAZY)
-	@Cascade(CascadeType.SAVE_UPDATE)
-    private Set<GenBankAccession> genBankAccession = new HashSet<GenBankAccession>();
-	
-	@XmlElement(name = "Locus")
-    @XmlIDREF
-    @XmlSchemaType(name = "IDREF")
-    @ManyToOne(fetch = FetchType.LAZY)
-    @Cascade(CascadeType.SAVE_UPDATE)
-	private Locus locus;
+//	//should be calculated in case sequence is set
+//	@XmlElement (name = "DateSequenced", type= String.class)
+//	@XmlJavaTypeAdapter(DateTimeAdapter.class)
+//	@Type(type="dateTimeUserType")
+//	@Basic(fetch = FetchType.LAZY)
+//	private DateTime dateSequenced;
 	
-	@XmlElementWrapper(name = "Chromatograms")
-	@XmlElement(name = "Chromatogram")
-    @XmlIDREF
-    @XmlSchemaType(name = "IDREF")
-    @OneToMany(fetch = FetchType.LAZY)
-	private Set<Media> chromatograms = new HashSet<Media>();
 	
 //*********************** FACTORY ****************************************************/
 	
-	public static Sequence NewInstance(String sequence){
+	public static Sequence NewInstance(String consensusSequence){
 		Sequence result = new Sequence();
-		result.setSequence(sequence);
+		result.setSequenceString(consensusSequence);
 		return result;
 	}
 	
-//*********************** CONSTRUCTOR ****************************************************/
 	
-	protected Sequence() {
-		super(); // FIXME I think this is explicit - do we really need to call this?
-		this.cacheStrategy = new IdentifiableEntityDefaultCacheStrategy<Sequence>();
+	public static Sequence NewInstance(String consensusSequence, Integer length){
+		Sequence result = NewInstance(consensusSequence);
+		result.getConsensusSequence().setLength(length);
+		return result;
 	}
+//*********************** CONSTRUCTOR ****************************************************/
+	
+	protected Sequence() {}
 
 //*********************** GETTER / SETTER ****************************************************/
 	
-	public Locus getLocus(){
-		return this.locus;
-	}
 
-	public void setLocus(Locus locus){
-		this.locus = locus;
+	/**
+	 * The {@link DnaSample dna sample} this sequencing belongs too. 
+	 */
+	public DnaSample getDnaSample() {
+		return dnaSample;
 	}
 
-	public Reference getPublishedIn(){
-		return this.publishedIn;
-	}
-	
-	public void setPublishedIn(Reference publishedIn){
-		this.publishedIn = publishedIn;
+	//TODO bidirectionality??
+	/**
+	 * @see #getDnaSample()
+	 */
+	private void setDnaSample(DnaSample dnaSample) {
+		this.dnaSample = dnaSample;
 	}
 
-	public Set<Reference> getCitations() {
-		return citations;
+	/**
+	 * The resulting consensus sequence represened by this {@link Sequence sequence} .
+	 * The consensus is usually computed from the {@link SingleRead single reads}.
+	 * The result of which is stored in a file called {@link #getContigFile() contig file}
+	 * 
+	 * #see {@link #getContigFile()}
+	 * #see {@link #getSingleReads()}
+	 */
+	public SequenceString getConsensusSequence() {
+		return consensusSequence;
 	}
-	protected void setCitations(Set<Reference> citations) {
-		this.citations = citations;
+
+
+	/**
+	 * @see #getConsensusSequence()
+	 */
+	public void setConsensusSequence(SequenceString sequenceString) {
+		if (sequenceString == null){
+			sequenceString = SequenceString.NewInstance();
+		}
+		this.consensusSequence = sequenceString;
 	}
-	public void addCitation(Reference citation) {
-		this.citations.add(citation);
+	
+	/**
+	 * The isBarcode flag should be set to true if this (consensus) sequence is or includes 
+	 * a barcoding sequence. If the barcoding sequence is only a part of the consensus sequence
+	 * this part shall be stored as {@link #getBarcodeSequencePart() barcoding sequence part}.
+	 * A isBarcode value of <code>null</code> indicates that we do have no knowledge
+	 * whether the sequence is a barcoding sequence or not.
+	 * 
+	 * @see #getBarcodeSequencePart()
+	 * @see #getSequenceString()
+	 * @returns the isBarcode flag value (tri-state)
+	 * 
+	 */
+	public Boolean getIsBarcode() {
+		return isBarcode;
 	}
-	public void removeCitation(Reference citation) {
-		this.citations.remove(citation);
+
+	/**
+	 * @see #getIsBarcode()
+	 * @see #getBarcodeSequencePart()
+	 */
+	public void setIsBarcode(Boolean isBarcode) {
+		this.isBarcode = isBarcode;
 	}
 
-	public Set<GenBankAccession> getGenBankAccession() {
-		return genBankAccession;
+	/**
+	 * If the barcode sequence string does not include 100% of the (consensus) sequence 
+	 * the part used as barcode is provided here. However, the barcode part
+	 * should be kept empty if consensus sequence string and barcode sequence string are equal.
+	 * 
+	 * @see #getIsBarcode()
+	 */
+	public SequenceString getBarcodeSequencePart() {
+		return barcodeSequencePart;
 	}
 
-	public void addGenBankAccession(GenBankAccession genBankAccession) {
-		this.genBankAccession.add(genBankAccession);
+	/**
+	 * @see #getBarcodeSequence()
+	 */
+	public void setBarcodeSequence(SequenceString barcodeSequencePart) {
+		if (barcodeSequencePart == null){
+			barcodeSequencePart = SequenceString.NewInstance();
+		}
+		this.barcodeSequencePart = barcodeSequencePart;
 	}
 	
-	public void removeGenBankAccession(GenBankAccession genBankAccession) {
-		this.genBankAccession.remove(genBankAccession);
+	/**
+	 * Sets the {@link TermType#DnaMarker DNA marker} examined and described by this sequencing.
+	 * The marker should usually be similar to the one used in the according {@link Amplification
+	 * amplification process}. However, it may slightly differ, or, if multiple amplifications where
+	 * used to build this consensus sequence it may be the super set of the markers used in amplification.
+	 * 
+	 * @return
+	 */
+	public DefinedTerm getDnaMarker(){
+		return this.dnaMarker;
 	}
-	
-	public Set<Media> getChromatograms() {
-		return chromatograms;
+
+	/**
+	 * @see #getDnaMarker()
+	 * @param marker
+	 */
+	public void setDnaMarker(DefinedTerm dnaMarker){
+		this.dnaMarker = dnaMarker;
 	}
 
-	public void addChromatogram(Media chromatogram) {
-		this.chromatograms.add(chromatogram);
+	/**
+	 * The accession number used in GenBank, EMBL and DDBJ.
+	 * @return
+	 */
+	public String getGeneticAccessionNumber() {
+		return geneticAccessionNumber;
 	}
-	
-	public void removeChromatogram(Media chromatogram) {
-		this.chromatograms.remove(chromatogram);
+
+	/**
+	 * Sets the genetic accession number.
+	 * @see #getGeneticAccessionNumber()
+	 */
+	public void setGeneticAccessionNumber(String geneticAccessionNumber) {
+		this.geneticAccessionNumber = geneticAccessionNumber;
 	}
 	
-	@Transient
-	public Set<Media> getMedia() {
-		return getChromatograms();
+
+	/**
+	 * The identifier used by the Barcode of Life Data Systems (BOLD, http://www.boldsystems.org/).
+	 */
+	public String getBoldProcessId() {
+		return boldProcessId;
 	}
 
-	public String getSequence(){
-		return this.sequence;
+	public void setBoldProcessId(String boldProcessId) {
+		this.boldProcessId = boldProcessId;
 	}
 
 	/**
-	 * 
-	 * @param sequence    sequence
+	 * Returns the name of the haplotype.
+	 * A haplotype (haploide genotype) is a variant of nucleotide sequences on the same chromosome.
+	 * A certain haplotype may be specific for an individual, a population or a species.
+	 * @return
 	 */
-	public void setSequence(String sequence){
-		this.sequence = sequence;
+	public String getHaplotype() {
+		return haplotype;
 	}
 
-	public Integer getLength(){
-		return this.length;
+	/**
+	 * @see #getHaplotype()
+	 */
+	public void setHaplotype(String haplotype) {
+		this.haplotype = haplotype;
 	}
 
 	/**
+	 * The contigFile containing all data and data processing for this sequencing.
 	 * 
-	 * @param length    length
+	 * @see #getConsensusSequence()
+	 * @see #getSingleReads()
 	 */
-	public void setLength(Integer length){
-		this.length = length;
+	public Media getContigFile() {
+		return contigFile;
 	}
 
-	public DateTime getDateSequenced(){
-		return this.dateSequenced;
+	/**
+	 * @see #getContigFile()
+	 */
+	public void setContigFile(Media contigFile) {
+		this.contigFile = contigFile;
+	}
+	
+	
+	/**
+	 * Citations are the set of references in which this sequence was published.
+	 * Unlike taxonomic names the first publication of a sequence
+	 * is not so important (maybe because it is required by publishers
+	 * that they are all registered at Genbank) therefore we do not have something like an 
+	 * "original reference" attribute.<BR> 
+	 * Links to these references are to be stored within the reference itself.
+	 * @return the set of references in which this sequence was published.
+	 */
+	public Set<Reference> getCitations() {
+		return citations;
+	}
+	/**
+	 * @see #getCitations()
+	 */
+	protected void setCitations(Set<Reference> citations) {
+		this.citations = citations;
+	}
+	/**
+	 * @see #getCitations()
+	 */
+	public void addCitation(Reference citation) {
+		this.citations.add(citation);
+	}
+	/**
+	 * @see #getCitations()
+	 */
+	public void removeCitation(Reference citation) {
+		this.citations.remove(citation);
 	}
 
 	/**
+	 * The {@link SingleRead single reads} that were used to build this consensus sequence.
 	 * 
-	 * @param dateSequenced    dateSequenced
+	 * @see #getConsensusSequence()
+	 * @see #getContigFile()
 	 */
-	public void setDateSequenced(DateTime dateSequenced){
-		this.dateSequenced = dateSequenced;
+	public Set<SingleRead> getSingleReads() {
+		return singleReads;
+	}
+	/**
+	 * @see #getSingleReads()
+	 */
+	public void addSingleRead(SingleRead singleRead) {
+		this.singleReads.add(singleRead);
+	}
+	/**
+	 * @see #getSingleReads()
+	 */
+	public void removeSingleRead(SingleRead singleRead) {
+		this.singleReads.remove(singleRead);
+	}
+	/**
+	 * @see #getSingleReads()
+	 */
+	//TODO private as long it is unclear how bidirectionality is handled
+	private void setSingleReads(Set<SingleRead> singleReads) {
+		this.singleReads = singleReads;
 	}
 
-	public boolean isBarcode(){
-		return this.barcode;
+
+	//*************************** Transient GETTER /SETTER *****************************/
+
+	/**
+	 * Delegate method to get the text representation of the consensus sequence
+	 * @see #setSequenceString(String)
+	 */
+	@Transient
+	public String getSequenceString() {
+		return consensusSequence.getString();
 	}
 
 	/**
-	 * 
-	 * @param isBarcode    isBarcode
+	 * Delegate method to set the text representation of the {@link #getConsensusSequence()
+	 * consensus sequence}.
+	 */
+	@Transient
+	public void setSequenceString(String sequence) {
+		consensusSequence.setString(sequence);
+	}
+	
+	/**
+	 * Convenience method which computes the set of all related pherograms
+	 * @return the set of pherograms.
 	 */
-	public void setBarcode(boolean barcode){
-		this.barcode = barcode;
+	@Transient
+	public Set<Media> getPherograms(){
+		Set<Media> result = new HashSet<Media>();
+		for (SingleRead singleSeq : singleReads){
+			if (singleSeq.getPherogram() != null){
+				result.add(singleSeq.getPherogram());
+			}
+		}
+		return result;
 	}
+	
 
-	public String getCitationMicroReference(){
-		return this.citationMicroReference;
+	//***** Registrations ************/
+	/**
+	 * Returns the computed genBank uri.
+	 * @return
+	 */
+	@Transient
+	public URI getGenBankUri() {
+		return createExternalUri(GENBANK_BASE_URI);
 	}
 
 	/**
-	 * 
-	 * @param citationMicroReference    citationMicroReference
+	 * Returns the computed EMBL uri.
+	 * @return
+	 */
+	@Transient
+	public URI getEmblUri() {
+		return createExternalUri(EMBL_BASE_URI);
+	}
+
+	/**
+	 * Returns the computed DDBJ uri.
+	 * @return
+	 */
+	@Transient
+	public URI getDdbjUri() {
+		return createExternalUri(DDBJ_BASE_URI);
+	}
+	
+	/**
+	 * Returns the URI for the BOLD entry.
+	 * @see #getBoldProcessId()
 	 */
-	public void setCitationMicroReference(String citationMicroReference){
-		this.citationMicroReference = citationMicroReference;
+	@Transient
+	public URI getBoldUri() {
+		return createExternalUri(BOLD_BASE_URI);
 	}
 
-	public Reference getCitation(){
-		return publishedIn;
+	
+	private URI createExternalUri(String baseUri){
+		if (StringUtils.isNotBlank(geneticAccessionNumber)){
+			return URI.create(String.format(baseUri, geneticAccessionNumber.trim()));
+		}else{
+			return null;
+		}
 	}
 	
+	
 	//*********************** CLONE ********************************************************/
 	/** 
 	 * Clones <i>this</i> sequence. This is a shortcut that enables to create
-	 * a new instance that differs only slightly from <i>this</i> sequence by
+	 * a new instance that differs only slightly from <i>this</i> sequencing by
 	 * modifying only some of the attributes.<BR><BR>
 	 * 
 	 *  
@@ -287,22 +514,24 @@ public class Sequence extends IdentifiableEntity<IIdentifiableEntityCacheStrateg
 		try{
 		Sequence result = (Sequence)super.clone();
 		
-		result.citations = new HashSet<Reference>();
-		for (Reference ref: this.citations){
-			result.citations.add((Reference) ref.clone());
+		//sequences
+		result.consensusSequence = (SequenceString)this.consensusSequence.clone();
+		result.barcodeSequencePart = (SequenceString)this.barcodeSequencePart.clone();
 		
+		
+		//single sequences
+		result.singleReads = new HashSet<SingleRead>();
+		for (SingleRead seq: this.singleReads){
+			result.singleReads.add((SingleRead) seq);
 		}
 		
-		result.genBankAccession = new HashSet<GenBankAccession>();
-		for (GenBankAccession genBankAcc: this.genBankAccession){
-			result.genBankAccession.add((GenBankAccession)genBankAcc.clone());
+		//citations  //TODO do we really want to copy these ??
+		result.citations = new HashSet<Reference>();
+		for (Reference ref: this.citations){
+			result.citations.add((Reference) ref);
 		}
 		
-		result.chromatograms = new HashSet<Media>();
 		
-		for (Media chromatogram: this.chromatograms){
-			result.chromatograms.add((Media)chromatogram.clone());
-		}
 		
 		return result;
 		}catch (CloneNotSupportedException e) {
@@ -311,4 +540,6 @@ public class Sequence extends IdentifiableEntity<IIdentifiableEntityCacheStrateg
 			return null;
 		}
 	}
+
+
 }
\ No newline at end of file
